<?php
/**
* Polish Language File developed by mybboard.pl for Hook finder 1.2
* Tłumaczenie: szulcu
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0
**/
function hook_finder_info()
{
    return array(
        "name"        => "Narzędzie: Hook-Finder",
        "description" => "Szybko wyszukuj odpowiednie haki do pluginów (ang. hooks)",
        "website"     => "http://mods.mybboard.net/",
        "author"      => "XxAnimusxX",
        "authorsite"  => "http://www.k-under.de",
        "version"     => "1.2",
        "guid"        => "c0e2be53377775a35a0d0bbed9b65220",
        "compatibility" => "14*"
        );
}

$plugins->add_hook("admin_tools_menu", "hookfinder_toolsmenu");
function hookfinder_toolsmenu($sub_menu)
{
        $sub_menu[] = array(
                      "id" => "hooks",
                      "title" => "Hook-Finder",
                      "link" => "index.php?module=tools/hooks"
                      );
}


$plugins->add_hook("admin_tools_action_handler", "hookfinder_actionhandler");
function hookfinder_actionhandler($action)
{
        $action['hooks'] = array('active' => 'hooks', 'file' => '');
}


$plugins->add_hook("admin_load", "admin_hookfinder");
function admin_hookfinder()
{
        global $page, $mybb, $db, $data, $cache;

        if ($page->active_action != "hooks")
        {
                return false;
        }
        $page->add_breadcrumb_item("Hook-Finder");

        $current_file = "";
        $data = unserialize(file_get_contents(MYBB_ROOT."inc/plugins/hooks.serial"));

        $dateline = $data[dateline];
        $version = my_date($mybb->settings['dateformat'], $dateline).", ".my_date($mybb->settings['timeformat'], $dateline);

        if ($dateline >= time()-(3600*24*7))
        {
                $message_text = "Baza Hook-Serials jest aktualna (ostatnia aktualizacja: ".$version.")";
                if ($dateline >= time()-4)
                {
                        $message_text = "Plik hook.serials został zaktualizowany";
                }
                flash_message($message_text, "success");
        }
        else
        {
               flash_message("Baza Hook-Serials jest nieaktualna (ostatnia aktualizacja: ".$version.")<br/>
               Naciśnij przycisk \"Zaktualizuj bazę Hook-Serials\", aby ją zaktualizować.");
        }

        if ($mybb->request_method == "post")
        {
                if ($mybb->input['file'])
                {
                        $current_file = $mybb->input['file'];
                }
                if ($mybb->input['update_all'])
                {
                        update_hookserials('all');
                }
                else if ($current_file && $mybb->input['update'])
                {
                        update_hookserials($current_file);
                }
                if ($mybb->input['check_plugins'])
                {
                        $page->add_breadcrumb_item("Hook-Finder: aktywne pluginy");
                        $page->output_header("Narzędzie: Hook-Finder (aktywne pluginy");

                        $table = new Table;
                        $table->construct_header("lista wszystkich haków użytych w pluginach", array("class"=>"align_center", "colspan"=>4));

                        $table->construct_cell("<strong>Plik pluginu</strong>");
                        $table->construct_cell("<strong>add_hook</strong>");
                        $table->construct_cell("<strong>funkcja pluginu</strong>");
                        $table->construct_cell("<strong>hak przekierowuje do</strong>");
                        $table->construct_row();

                        $active_plugins = $cache->cache['plugins']['active'];
                        foreach ($active_plugins as $file => $name)
                        {
                                $table->construct_cell($file.".php");
                                $temp_data = file(MYBB_ROOT."inc/plugins/".$file.".php");
                                $temp_hooks = ""; $temp_functions = ""; $temp_redirect = "";
                                for ($j=0; $j<count($temp_data); $j++)
                                {
                                        if (preg_match("!".preg_quote("\$plugins->add_hook(")."[\"|'](.+)[\"|'],\s*?[\"|'](.+)[\"|']\);!", $temp_data[$j], $hits))
                                        {
                                                if($temp_hooks) $temp_hooks.="<br/>";
                                                $temp_hooks.= $hits[1];
                                                if ($temp_functions) $temp_functions.="<br/>";
                                                $temp_functions.= $hits[2];
                                                if ($temp_redirect) $temp_redirect.="<br/>";
                                                $temp_redirect .= getHookRedirect($hits[1]);
                                        }
                                }
                                $table->construct_cell($temp_hooks);
                                $table->construct_cell($temp_functions);
                                $table->construct_cell($temp_redirect);
                                $table->construct_row();
                        }

                        $table->output("Hook-Finder: aktywne pluginy");
                        $page->output_footer();
                        exit;
                }
        }

        $options = "";
        foreach ($data['list'] as $cat=>$files_array)
        {
                $options .= "\t<optgroup label='$cat'>\n";
                foreach ($files_array as $name => $infos)
                {
                        $checked = $current_file == "$cat|$name"? " selected":"";
                        $options.="\t\t<option value='$cat|$name'".$checked.">$name</option>\n";
                }
                $options .= "\t</optgroup>\n";
        }

        $form = new Form("index.php?module=tools/hooks", "post");
        $page->output_header("Narzędzie: Hook-Finder");

        $form = new Form("index.php?module=tools/hooks", "post");
        $table = new Table;
        $table->construct_header("\n<select name='file' onChange='this.form.submit();'>\n\t<option value=''>-------------</option>\n$options</select>\n", array('class' => 'align_center', 'colspan' => 3));

        $info = getFileData($current_file);
        if (!$info)
        {
                $table->construct_cell("Wybierz plik z listy powyżej.", array("style" => "text-align:center"));
                $table->construct_row();
        }
        else
        {
                $table->construct_cell("<strong>Linia #</strong>", array('width'=>"10%", "class" => "align_center"));
                $table->construct_cell("<strong>Nazwa haka</strong>");
                $table->construct_cell("<strong>ref</strong>");
                $table->construct_row();

                foreach($info as $line => $infos)
                {
                        $table->construct_cell($line, array('class' => 'align_center'));
                        $table->construct_cell($infos[hook]);
                        $table->construct_cell($infos[ref]);
                        $table->construct_row();
                }
                $add_update = " <input type='submit' value='Zaktualizuj bazę Hook-Serial dla tego pliku' name='update'>";
        }

        $table->construct_cell(
        "<div style='float:left;'><input type='submit' name='check_plugins' value='Pokaż aktywne pluginy'/></div><input type='submit' name='update_all' onClick='if(!confirm(\"Trwa próba aktualizacji bazy danych o hakach.\\nTen proces może zająć trochę czasu z uwagi na dużą ilość plików do przetworzenia.\\nNie zamykaj okna przeglądarki do momentu jego zakończenia.\"))return false;' value='Zaktualizuj bazę Hook-Serials'>".$add_update,
        array('style' => 'text-align: right;', 'colspan' => 3)
        );

        $table->construct_row();

        $table->output("Hook-Finder");
        $form->end();

        $page->output_footer();
        exit;
}

function getFileData($filename)
{
        global $data;

        if (!$filename) return false;

        list($cat, $file) = explode("|", $filename);
        $temp_data = $data['list'][$cat][$file];

        if (!$temp_data) return false;

        return $temp_data;
}

function update_hookserials($file)
{
        global $phps, $php_dirs;

        if ($file == "all")
        {
                $phps = array();
                $php_dirs = array();
                getPHPs();

                $hookserial = array("dateline" => time());
                for ($i=0; $i<count($phps); $i++)
                {
                        $file = file($phps[$i]);
                        for ($j=0; $j<count($file); $j++)
                        {
                                $path = getPath($phps[$i]);
                                $name = getName($phps[$i]);
                                if (preg_match("!".preg_quote("\$plugins->run_hooks(\"")."(.*?)\"\);!", $file[$j], $treffer))
                                {
                                        $hookserial['list'][$path][$name][$j+1] = array(
                                                          "hook" => $treffer[1]
                                                          );
                                }

                                if (preg_match("!".preg_quote("\$plugins->run_hooks_by_ref(\"")."(.*?)\", (.*?)\);!", $file[$j], $treffer))
                                {
                                        $hookserial['list'][$path][$name][$j+1] = array(
                                                          "hook" => $treffer[1],
                                                          "ref" => $treffer[2]
                                                          );
                                }
                        }
                }
        }
        else
        {
                list($path, $filename) = explode("|", $file);
                $path_rel = str_replace("MyBB-Root", MYBB_ROOT, $path);

                $data = @file($path_rel."/".$filename);
                for ($i=0; $i<count($data); $i++)
                {
                        if (preg_match("!".preg_quote("\$plugins->run_hooks(\"")."(.*?)\"\);!", $data[$i], $treffer))
                        {
                                $infos['list'][$path][$filename][$i+1] = array(
                                                          "hook" => $treffer[1]
                                                          );
                        }

                        if (preg_match("!".preg_quote("\$plugins->run_hooks_by_ref(\"")."(.*?)\", (.*?)\);!", $data[$i], $treffer))
                        {
                                $infos['list'][$path][$filename][$i+1] = array(
                                                          "hook" => $treffer[1],
                                                          "ref" => $treffer[2]
                                                          );
                        }
                }
                $hookserial = file_get_contents(MYBB_ROOT."inc/plugins/hooks.serial");
                $hookserial = unserialize($hookserial);

                foreach ($infos['list'][$path] as $filename => $line_data)
                {
                        $hookserial['list'][$path][$filename] = $line_data;
                }
        }

        if ($hookserial)
        {
                $handle = fopen(MYBB_ROOT."inc/plugins/hooks.serial", "w");
                fwrite($handle, serialize($hookserial));
                fclose($handle);
        }
}

function getPHPs($reldir = "")
{
        global $phps, $php_dirs;

        if (!$reldir) $reldir = MYBB_ROOT."/";
        $temp_array = glob($reldir."*.php");

        if ($temp_array)
        {
                foreach ($temp_array as $file)
                {
                        $phps[] = $file;
                }
        }

        $subdirs = glob($reldir."*", GLOB_ONLYDIR);
        for ($i=0; $i<count($subdirs); $i++)
        {
                getPHPs($subdirs[$i]."/");
        }
}
function getPath($path)
{
        $temp = explode("/", $path);
        $t = "";
        for ($i=0; $i<count($temp)-1; $i++)
        {
                if($t) $t.="/";
                $t.=$temp[$i];
        }
        return str_replace(MYBB_ROOT, "MyBB-Root", $t);
}
function getName($name)
{
        $temp = explode("/", $name);
        return $temp[(count($temp)-1)];
}

function getHookRedirect($hookname)
{
        global $data;
        $list = $data['list'];
        foreach ($list as $path => $files)
        {
                foreach ($files as $filename => $hooks_data)
                {
                        foreach($hooks_data as $line => $hook)
                        {
                                if ($hookname == $hook['hook'])
                                {
                                        return "[$line] ".str_replace("MyBB-Root",".",$path)."/".$filename;
                                }
                        }
                }
        }
}

?>